<template>
  <div class="container">
    <div class="radio" v-for="input in slide.inputs">
      <label>
        <input type="radio"
          :name="slide.name"
          @click="click(input)"
          :value="input.option"
          :checked="defaultChecked == input.option" />
        {{input.option}}
      </label>
    </div>
  </div>
</template>

<script>
  import Store from '../stores/app.store';
  export default {
    name: "survey-input-options",
    props: [ 'name' ],
    data: function() {
      var self = this;
      var slide = Store.getters.slide(this.name);
      var controls = slide.inputs || [];
      if (!controls || !controls.length) { return null; }

      function checkDefault() {
        if (slide.selection) {
          for (var i = 0; i < controls.length; i++) {
            if (controls[i].option == slide.selection) {
              self.click(controls[i]);
              return controls[i].option;
            }
          }
        }
        for (var i = 0; i < controls.length; i++) {
          if (controls[i].defaultIf == 'always') {
            self.click(controls[i]);
            return controls[i].option;
          } else if (controls[i].defaultIf) {
            if (Store.state.metadata[controls[i].defaultIf]) {
              self.click(controls[i]);
              return controls[i].option;
            }
          }
        }
        return null;
      }

      return {
        slide: slide,
        defaultChecked: checkDefault()
      };
    },
    methods: {
      click: function(input) {
        var value = 0;

        if (input.addValue)
          value += input.addValue;

        if (input.subtractValue)
          value -= input.subtractValue;

        Store.commit('updateSlide', {
          name: this.name,
          selection: input.option,
          text: input.changeText,
          valueNote: input.changeValueNote,
          footnote: input.chanageFootnote,
          meta: input.addMeta,
          next: input.next || Store.state.survey.slidesArray[Store.state.survey.currentSlideIndex + 1],
          runningValue: value
        });

        if (input.addMeta) {
          Store.commit('addMeta', input.addMeta);
        }

      }
    }
  }
</script>

<style scoped>
  label {
    font-size: 1.3em;
  }

  .container {
    width: 50%;
    margin: 3em auto;
    text-align: left;
    white-space: nowrap;
  }
</style>
